Prime Path(bfs,素数打表)

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

sample input

3
1033 8179
1373 8017
1033 1033

samole output

6
7
0

题目简述:
一个总统需要换房间号,但又要自己的房间号是素数,输入开头素数和结束素数,求要通过多少次变换才能使第一个数变到最后一个数。
题目分析:
一道bfs、素数打表题。
程序实现:

#include "pch.h"
#include <iostream>
#include<queue>
#include<cstring>
#include<cmath>
#include<algorithm>
using namespace std;
#define maxn 10000
bool p1[maxn + 1];//建立素数表,里面成员一为素数0为和数
bool v[maxn + 1];
int c[maxn + 1];//相当于计数器
void prime()
{
 int i, j, n;
 memset(p1, true, sizeof(p1));
 for (i = 2; i <maxn/2; i++)
 {
  if(p1[i])
  for (j = i + i; j < maxn; j += i)//两素数的和一定是和数
   p1[j] = false;
 }
}
int BFS(int x, int y)
{
 queue<int> q;//申请列队
 q.push(x);//把x压进q中
 v[x] = true;
 while (!q.empty())
 {
  int now = q.front();
   q.pop();
   for (int i = 0; i <= 9; i++)
   {
    int temp = (now / 10) * 10 + i;//暴力寻找个位
    if (p1[temp] == true && v[temp] == false)
    {
     q.push(temp);
     v[temp] = true;
     c[temp] = c[now] + 1;
    }
    temp = (now / 100) * 100 + i * 10 + now % 10;//暴力找十位
    if (p1[temp] == true && v[temp] == false)
    {
     q.push(temp);
     v[temp] = true;
     c[temp] = c[now] + 1;
    }
    temp = (now / 1000) * 1000 + i * 100 + now % 100;//暴力找千位
    if (p1[temp] == true && v[temp] == false)
    {
     q.push(temp);
     v[temp] = true;
     c[temp] = c[now] + 1;
    }
    temp =  i * 1000 + now % 1000;//暴力找万位
    if (i!=0&&p1[temp] == true && v[temp] == false)
    {
     q.push(temp);
     v[temp] = true;
     c[temp] = c[now] + 1;
    }
    if (v[y])
     return c[y];
   }
 }
}
int main()
{
 prime();
 int n;
 cin >> n;
 while (n--)
 {
  int start, end;
  memset(v, false, sizeof(v));
  memset(c, 0, sizeof(c));
  cin >> start >> end;
  cout << BFS(start, end) << endl;
 }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值